#include <stdio.h>
#include <stdlib.h>
#include "kp.h"
#include "bb.h"

/* pour afficher bien la solution */
int cmp1(const void *a, const void *b)
{  int x = *((int *)a);
   int y = *((int *)b);
   
   if (x < y) return -1;
   if (x > y) return 1;
   return 0;
}

int main(int argc, char **argv)
{  kp_t *kp;
   sp_t sp, sol;
   int i;
   
   kp = lire_kp(argv[1]);
   sp = malloc((kp->n + 4) * sizeof(int));
   sol = malloc((kp->n + 4) * sizeof(int));
   
   trier_objets(kp, sp);
   sol_glouton(kp, sp, sol);
   branch_and_bound(kp, sp, sol);

   qsort(FIX1(sol), NFIX1(sol), sizeof(int), cmp1);
   printf("\nSOLUTION OPTIMALE :\n");
   printf("  COUT  : %10d\n  RESTE : %10d\n", C(sol), B(sol));
   printf("  OBJETS :\n");
   for (i = 0; i < NFIX1(sol); i++)
      printf("%20d\n", FIX1(sol)[i]);
   
   free_kp(kp);
   free(sol);
   return 0;
}
