#include <stdlib.h>
#include "pool.h"

pool_t *p_init()
{  pool_t *pool;

   pool = malloc(sizeof(pool_t));
   pool->n = 0;
   pool->cap = CAPACITE_INITIALE;
   pool->sp = malloc((pool->cap) * sizeof(sp_t));
   return pool;
}

/* netoyage du pool */
void p_free(pool_t *pool)
{  free(pool->sp);
   free(pool);
}


/* verifie si le pool est vide */
int p_isempty(pool_t *p)
{  return p->n == 0;
}


void p_add(pool_t *pool, sp_t sp)
{  if (pool->n == pool->cap)
   {  pool->cap *= 2;
      pool->sp = realloc(pool->sp, pool->cap * sizeof(sp_t));
   }
   pool->sp[pool->n++] = sp;
}


sp_t p_extract(pool_t *pool)
{  return pool->sp[--pool->n];
}
